Program ImageProg;
{
Implementering af 'Genkendelse af tegn: Opgaven Image
til DDD '98 af Kristoffer Hansen, Holstebro Gymnasium
}

{
 Metoden benyttet her er en sgning for det bedst passende tegn til en given
 placering. Der benyttes dynamisk programmering til at gre rekursionen,
 der optller det mindst mulige antal af fejl mellem tegn og billede til
 en given position, hurtigst mulig.
 Et problem kan vre at finde ud af hvor prcis nste tegn starter.
 Her er det lst ved simpelt hen at prve hvor tegnene bedst passer indenfor
 +-1 af den nuvrende position i billedet.
 Dette er muligt idet det jo i opgaven er givet at
 'Alle tegnbillede i de anvendte evalueringsdatafiler kan genkendes et for
 et af et velskrevet program.'
 og 'Der findes n og kun n bedste lsning for ethvert st af
 evalueringsdatafiler.'

 Lsningen er med andre ord entydigt givet og det er s bare et sprgsml om
 at finde mindst antal fejl.

 Der er sledes heller ikke indbygget kontrol for at programmet ikke kan
 genkende et tegn, men det skulle der forhbentligt heller ikke vre brug
 for :-)

 For vrigt konverteres de 20 karakterer lange tal som en billedlinie er
 lavet af til 20-bits tal fordelt over 5 nibbles. Dette muliggrer at hele
 billedet kan indlses i hukommelsen og der kan laves sammenligningstabeller
 for alle kombinationer af billedlinier for hvert tegn, hvad der gr sammen-
 ligningen betydeligt hurtigere og nemmere.
}

const
   fontname = 'font.dat';
   imagename = 'image.dat';
   outname = 'image.out';

   maximagelines = 1200;

   nibblesize = 4;
   numchars = 27;
   fontchars : array[1..numchars] of char = ' abcdefghijklmnopqrstuvwxyz';
   charlength = 20;
   charlines = 20;
   nibblesperline = (charlength div nibblesize);
   permnibble = 2*2*2*2 - 1;

type
   nibble = byte;
   tnibblediff = array[0..permnibble,0..permnibble] of byte;
   ttegndiff = array[1..numchars, 1..charlines ,1..nibblesperline, 0..permnibble] of nibble;
   timage = array[1..maximagelines,1..nibblesperline] of nibble;

var
  n : nibble;
  nibblediff : ^tnibblediff;
  tegndiff : ^ttegndiff;
  fontfile, imagefile, outfile : text;
  image : ^timage;
  numilines : word;
  resstring : string[60];

function stringtonibble(s : string ; index : byte) : byte;
{konverterer 4 bogstaver til en nibble}
var
   res : nibble;

begin
   res := 0;
   if s[1+index] = '1' then inc(res,8);
   if s[2+index] = '1' then inc(res,4);
   if s[3+index] = '1' then inc(res,2);
   if s[4+index] = '1' then inc(res,1);
   stringtonibble := res;
end;

procedure BuildNibbleDiffTable;
{ Skaber forskelstabeller for alle kombinationer af nibbles}
function diffnibble(i, j : nibble) : byte;
{giver forskellen p to nibbles}
var
  return : byte;

begin
    return := 0;
    if ((i and 8)=8) xor ((j and 8) = 8) then inc(return);
    if ((i and 4)=4) xor ((j and 4) = 4) then inc(return);
    if ((i and 2)=2) xor ((j and 2) = 2) then inc(return);
    if ((i and 1)=1) xor ((j and 1) = 1) then inc(return);
    diffnibble := return;
end;

var
   i, j : nibble;

begin
    for i := 0 to permnibble do
      for j := 0 to permnibble do
      begin
         Nibblediff^[i,j] := diffnibble(i,j);
      end;
end;

Procedure ReadData;
{indlser font og hele billedet + skaber tabeller til fonten}

var
   str : string[20];
   i, j, k, l  : word;

begin
   assign(fontfile,fontname);
   reset(fontfile);
   readln(fontfile);    { skip antallet }
   for i := 1 to numchars do
    for j := 1 to charlines do
    begin
     readln(fontfile,str);
     for k := 1 to nibblesperline do
       for l := 0 to permnibble do
       begin
            tegndiff^[i,j,k,l] := nibblediff^[stringtonibble(str, (k-1)*nibblesize), l];
       end;
   end;
   close(fontfile);

   assign(imagefile, imagename);
   reset(imagefile);
   readln(imagefile, numilines);
   for i := 1 to numilines do
   begin
      readln(imagefile, str);
      for j := 1 to nibblesperline do
         image^[i,j] := stringtonibble(str, (j-1)*nibblesize);
   end;
   close(imagefile);
end;

function LineDiff(cchar,cline : byte; line : word ) : byte;
{beregner forskellen p en hel billed-linie og en linie fra et bogstav}
var
   diff : byte;
   i : byte;

begin
   diff := 0;
   for i := 1 to nibblesperline do
     inc(diff, tegndiff^[cchar,cline,i,image^[line,i]]);
   LineDiff := diff;
end;

const
   notfilled = 65535;

var
   dynbuf : array[1..CharLines,1..3] of word;

{ stat: 1 = mistet linie ; 2 = normal ; 3 = dubleret linie }

function recurse(cchar,cline,stat : byte; iline : word) : word;
{selve funktionen der rekurseres i}
var
   d1, d2, d3 : word;

begin
   if cline = charlines then            { er vi i bunden af tret ?}
   begin
       if (stat = 1) or (stat=3) then
         recurse := LineDiff(cchar,cline,iline);
       if stat = 2 then
         begin
           d1 := 0;
           d2 := LineDiff(cchar,cline,iline);
           d3 := LineDiff(cchar,cline,iline+1);

           if d1 < d2 then
              d2 := d1;

           if d3 < d2 then        { bliver aldrig taget, men med for helhedens skyld:-)}
              d2 := d3;

           recurse := d2;
         end;
   end
   else
   begin
      if stat = 2 then            { hvis der ikke er liniefejl endnu skal 3 veje afprves}
      begin

         if dynbuf[cline+1,1] = notfilled then
            dynbuf[cline+1,1]  := recurse(cchar,cline+1,1,iline);

         if dynbuf[cline+1,2] = notfilled then
            dynbuf[cline+1,2]  := recurse(cchar,cline+1,2,iline+1);

         if dynbuf[cline+1,3] = notfilled then
            dynbuf[cline+1,3]  := recurse(cchar,cline,3,iline+1);

         d1 := dynbuf[cline+1,1];
         d2 := dynbuf[cline+1,2];
         d3 := dynbuf[cline+1,3];

         if d1 < d2 then
            d2 := d1;

         if d3 < d2 then
            d2 := d3;

         recurse := d2 + linediff(cchar,cline,iline);
      end
      else
      if stat = 1 then     { ellers forst nedad af samme gren }
      begin
         if dynbuf[cline+1,1] = notfilled then
            dynbuf[cline+1,1]  := recurse(cchar,cline+1,1,iline+1);
            recurse := dynbuf[cline+1,1] + linediff(cchar,cline,iline);
      end
      else
      if stat = 3 then     { ditto her }
      begin
         if dynbuf[cline+1,3] = notfilled then
            dynbuf[cline+1,3]  := recurse(cchar,cline+1,3,iline+1);
            recurse := dynbuf[cline+1,3] + linediff(cchar,cline,iline);
      end;
   end;
end;

Procedure Clearbuffer;
var
  i,j : word;

begin
   for i := 1 to charlines do
     for j := 1 to 3 do
     begin
        dynbuf[i,j] := notfilled;
     end;

end;

Procedure GenerateSolution;
var
   i : word;
   j : shortint;
   index : word;
   strindex : byte;
   diff : array[1..numchars] of word;
   minerr : word;
   bestchar : char;
   bestj : word;

begin
   index := 1;

   while index < numilines do      {slnge der er billede tilbage }
   begin

    minerr := notfilled;

    for j := -1 to 1 do            {prv de tre mulige positioner for tegnet}
    begin
     if ((index+j)>0) and ((index+j) < numilines) then   {hold grnserne for billedet}
     begin
      for i := 1 to numchars do
      begin                    { start rekursionen... }
        ClearBuffer;
        diff[i] := recurse(i,1,2,index+j); {char,cline,stat,iline}
      end;

      for i := 1 to numchars do         { find det bedste tegn }
        if (diff[i] < minerr) then
        begin
           minerr := diff[i];
           bestchar := fontchars[i];
           bestj := j;
        end;
     end;
    end;

    resstring := resstring + bestchar;  { og tilfj til lsningen }
    inc(index,20+bestj);
   end;
end;

Procedure WriteData;
begin
   assign(Outfile,OutName);
   rewrite(Outfile);
   writeln(outfile,resstring);
   close(outfile);
end;

begin
   new(NibbleDiff);
   new(TegnDiff);
   new(Image);

   BuildNibbleDiffTable;       { skab den indledende nibble-tabel }
   ReadData;                   { indls alt data og skab tabeller }
   GenerateSolution;           { find en lsning                  }
   WriteData;                  { of skriv den til ud-filen        }
end.