program maps;
{ Skrevet 10-11/3 98 af Erik Se Srensen }
{$B- R- S- I-}
uses
  crt;
const
  NotHere=20000;
type
  byrec=record
    postnr:integer;

    x,y:integer;
    w,h:integer;
    block:array[0..3] of integer;

    xmin,ymin,ymax:integer;
    foer,efter:integer;  { Binrt tr til sortering }
    plads:shortint;
  end;
  byliste=array[0..1000] of byrec;
var
  antal:integer;
  by:byliste;
  listepos:integer;
  cursorx,cursory:integer;


    { Sorteringsprocedurer }
procedure InitSort;
begin
  with by[0] do begin
    foer:=-1;efter:=-1;
    ymin:=500;ymax:=500;
  end;
  listepos:=0;
end;

procedure Insert(ins:byrec);
var
  cur:integer;
  placeret:boolean;
begin
  with ins do begin foer:=-1;efter:=-1; end;
  cur:=0;placeret:=false;
  repeat with by[cur] do begin
    if ins.ymin<ymin then begin
      if foer<>-1 then cur:=foer else begin
        inc(listepos);by[listepos]:=ins;
        foer:=listepos;
        placeret:=true;
      end;
    end else begin
      if efter<>-1 then cur:=efter else begin
        inc(listepos);by[listepos]:=ins;
        efter:=listepos;
        placeret:=true;
      end;
    end;
  end until placeret;
end;

procedure LineUp;
var
  templiste:^byliste;

procedure traverser(cur:integer);
begin
  with templiste^[cur] do begin
    if foer<>-1 then begin
      traverser(foer);
    end;

    if cur>0 then begin
      inc(listepos);by[listepos]:=templiste^[cur];
    end;

    if efter<>-1 then begin
      traverser(efter);
    end;
  end;
end;

begin
  new(templiste);
  templiste^:=by;

  listepos:=0;
  traverser(0);

  dispose(templiste);
end;

              { Ls og skriv data }

procedure ReadMap;
var
  fil:text;
  tempby:byrec;
  namel:integer;
  s:string;
  t:integer;
  p:byte;

procedure LaesTal(var tal:integer);
begin
  while s[p]=' ' do inc(p);
  tal:=0;
  while s[p]<>' ' do begin
    tal:=tal*10+ord(s[p])-48;
    inc(p);
  end;
end;

procedure LaesNavn(var namel:integer);
var
  navn:string;
begin
  while s[p]=' ' do inc(p);
  namel:=0;navn:='';
  while (s[p]<>' ') and (p<=length(s)) do begin
    inc(namel);navn:=navn+s[p];
    inc(p);
  end;
  namel:=namel+1; {Husk mellemrummet}
{  writeln('''',navn,'''',namel:5);}
end;

begin
  cursorx:=wherex;cursory:=wherey;

  InitSort;

  assign(fil,'Maps.dat');reset(fil);
  readln(fil,antal);
  for t:=1 to antal do begin
    if t mod 50=0 then begin gotoxy(75,1);write(t:4);end;
    with tempby do begin
      postnr:=t;

      readln(fil,s);
      p:=1;
      LaesTal(x);LaesTal(y);LaesTal(w);LaesTal(h);
      LaesNavn(namel);
      w:=w*namel;

      xmin:=x-w;ymin:=y-h;
      ymax:=y+h;
    end;
    Insert(tempby);
  end;
  close(fil);

  LineUp;

  gotoxy(cursorx,cursory);
end;

procedure WriteMap;
var
  fil:text;
  posliste:array[1..1000] of record
    px,py:integer;
  end;
  t:integer;
  placeret:integer;
begin
  for t:=1 to 1000 do with posliste[t] do begin px:=-1;py:=-1; end;
  placeret:=0;
  for t:=1 to antal do with by[t] do if plads>0 then begin
    inc(placeret);
    with posliste[Postnr] do begin
      px:=xmin;if plads and 1>0 then inc(px,w+1);
      py:=ymin+(h-1);if plads and 2>0 then inc(py,h+1);
    end;
  end;
  writeln;writeln('Placeret: ',placeret,'/',antal);
  assign(fil,'Maps.out');rewrite(fil);
  for t:=1 to antal do with posliste[t] do writeln(fil,px,' ',py);
  close(fil);
end;


          { Procedurer til placering af labels }
var
  lax1,lay1,lax2,lay2:integer;

function overlapby(b:integer):boolean;
begin
  with by[b] do begin
    overlapby:=(lax1<=x) and (x<=lax2)
           and (lay1<=y) and (y<=lay2);
  end;
end;

function overlaplbl(b:integer;lblnrb:byte):boolean;
var
  lbx1,lby1,lbx2,lby2:integer;
label NoOverlap;
begin
  with by[b] do begin
    lbx1:=xmin;if lblnrb and 1>0 then inc(lbx1,w+1);
    lby1:=ymin;if lblnrb and 2>0 then inc(lby1,h+1);
    lbx2:=lbx1+w-1;
    lby2:=lby1+h-1;
  end;

  overlaplbl:=false;
  if lax2<lbx1 then goto NoOverlap;if lax1>lbx2 then goto NoOverlap;
  if lay2<lby1 then goto NoOverlap;if lay1>lby2 then goto NoOverlap;
  overlaplbl:=true;
  NoOverlap:
end;

procedure placer;
var
  t,t2:integer;
  max:integer;
  labl,labl2:byte;
  top50:array[1..500] of record
    Tby:integer;Tlabel:byte;
    Tblock:integer;
  end;
  mangler,bedste:integer;
  xx,yy:integer;
label overwritten;
begin
  cursorx:=wherex;cursory:=wherey;

  for t:=1 to antal do with by[t] do begin
    for labl:=0 to 3 do block[labl]:=0;
    plads:=0;
  end;

                { Marker illegale labels }
  for t:=1 to antal do with by[t] do begin
    max:=t;while (max<antal) and (by[max+1].ymin<=ymax) do inc(max);
    for labl:=0 to 3 do begin
      lax1:=xmin;if labl and 1>0 then inc(lax1,w+1);
      lay1:=ymin;if labl and 2>0 then inc(lay1,h+1);
      lax2:=lax1+w-1;
      lay2:=lay1+h-1;

      if (lax1<0) or (lax2>999) or (lay1<0) or (lay2>999) then
        block[labl]:=NotHere; {Regel 4}

      for t2:=t+1 to max do if overlapby(t2) then block[labl]:=NotHere; {Regel 3}
    end;
    for t2:=t+1 to max do with by[t2] do begin
      for labl:=0 to 3 do begin
        lax1:=xmin;if labl and 1>0 then inc(lax1,w+1);
        lay1:=ymin;if labl and 2>0 then inc(lay1,h+1);
        lax2:=lax1+w-1;
        lay2:=lay1+h-1;

        if overlapby(t) then block[labl]:=NotHere; {Regel 3}
      end;
    end;
  end;

  repeat
    for t:=1 to antal do with by[t] do begin
      for labl:=0 to 3 do if block[labl]<>NotHere then block[labl]:=0;
    end;
                  { Tl overlap op }
    for t:=1 to antal do with by[t] do if (plads>=0) then begin
      max:=t;while (max<antal) and (by[max+1].ymin<=ymax) do inc(max);
      for labl:=0 to 3 do if block[labl]<>NotHere then begin
        lax1:=xmin;if labl and 1>0 then inc(lax1,w+1);
        lay1:=ymin;if labl and 2>0 then inc(lay1,h+1);
        lax2:=lax1+w-1;
        lay2:=lay1+h-1;

        for t2:=t+1 to max do if (by[t2].plads>=0) then for labl2:=0 to 3 do if by[t2].block[labl2]<>NotHere then begin
          if overlaplbl(t2,labl2) then begin
            inc(by[t].block[labl]);inc(by[t2].block[labl2]);
          end;
        end;
      end;
    end;

                { Lav Top 50 }
    mangler:=0;
    for t:=1 to 50 do top50[t].Tblock:=10000;
    for t:=1 to antal do with by[t] do if (plads=0) then begin
      plads:=-1;
      for labl:=0 to 3 do if block[labl]<>NotHere then begin
        plads:=0;
        t2:=51;while (t2>1) and (block[labl]<top50[t2-1].Tblock) do dec(t2);
        if t2<=50 then begin
          if t2<50 then move(top50[t2],top50[t2+1],sizeof(top50[t2])*(50-t2));
          with top50[t2] do begin
            Tby:=t;Tlabel:=labl;Tblock:=block[labl];
          end;
        end;
      end;
      if plads=0 then inc(mangler);
    end;

              { Placer de 'bedste' labels }
    bedste:=top50[1].Tblock;if bedste>=10000 then bedste:=1;
    t:=1;
    while (t<=50) and (top50[t].Tblock<=bedste+bedste shr 2) do with top50[t] do begin
      with by[Tby] do if block[Tlabel]<>NotHere then begin        { Placer }
        lax1:=xmin;if Tlabel and 1>0 then inc(lax1,w+1);
        lay1:=ymin;if Tlabel and 2>0 then inc(lay1,h+1);
        lax2:=lax1+w-1;
        lay2:=lay1+h-1;

        max:=Tby;while (max<antal) and (by[max+1].ymin<=ymax) do inc(max);
        for t2:=Tby+1 to max do for labl2:=0 to 3 do if by[t2].block[labl2]<>NotHere then begin
          if (by[t2].plads>0) and overlaplbl(t2,labl2) then begin
            block[Tlabel]:=NotHere;
            goto overwritten;
          end;
        end;
        for t2:=Tby+1 to max do for labl2:=0 to 3 do if by[t2].block[labl2]<>NotHere then begin
          if overlaplbl(t2,labl2) then begin
            by[t2].block[labl2]:=NotHere;
          end;
        end;

        for t2:=0 to 3 do if t2<>Tlabel then block[t2]:=NotHere;
        plads:=Tlabel or 4;
      end;
overwritten:
      inc(t);
    end;
    gotoxy(75,1);write(mangler:4);
  until mangler=0;

  gotoxy(cursorx,cursory);
end;


var code:integer;
begin
    Writeln('Lser...');
  ReadMap;
    Writeln('Placerer...');
  Placer;
    Writeln('Skriver...');
  WriteMap;
end.